unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls,
  IdHTTP,
  ExtCtrls, CheckLst, Buttons,
  UntRepository,urlmon;

type
  TMain = class(TForm)
    Pages: TPageControl;
    PageConfig: TTabSheet;
    chkProxi: TCheckBox;
    edProxiServer: TEdit;
    Label1: TLabel;
    edProxiPort: TEdit;
    Label2: TLabel;
    edProxiUser: TEdit;
    Label3: TLabel;
    edProxiPassword: TEdit;
    Label4: TLabel;
    PageRepositories: TTabSheet;
    memRepo: TMemo;
    pnlRepo: TPanel;
    btRepoRefresh: TButton;
    edRepoDir: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    edRepoTmp: TEdit;
    Bevel1: TBevel;
    PageFiles: TTabSheet;
    Panel1: TPanel;
    btDebRefresh: TButton;
    chklstDEBS: TCheckListBox;
    btDownload: TButton;
    lblStatus1: TLabel;
    lblStatus2: TLabel;
    SaveRepoDlg: TSaveDialog;
    OpenRepoDlg: TOpenDialog;
    btRepoGuardar: TButton;
    btRepoAbrir: TButton;
    btImport: TButton;
    btUnmmark: TButton;
    tbtBuscar: TEdit;
    Button1: TButton;
    Label7: TLabel;
    cbArq: TComboBox;
    ConnMode: TRadioGroup;
    Label8: TLabel;
    procedure btImportClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btRepoRefreshClick(Sender: TObject);
    procedure btRepoSaveClick(Sender: TObject);
    procedure btDebRefreshClick(Sender: TObject);
    procedure btDownloadClick(Sender: TObject);
    procedure btRepoGuardarClick(Sender: TObject);
    procedure btRepoAbrirClick(Sender: TObject);
    procedure btUnmmarkClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure chkProxiClick(Sender: TObject);
  private
    { Private declarations }
    fRep:TRepository;
    FileGET: TIdHTTP;
    procedure Crear;
    procedure Destruir;
    procedure LoadRepository;
    function DownLoadFile(const aSource,aDest:String):Boolean;
    procedure AddToRepository(const aUrl:String;const ssl:TStringList;const aUrl2:String);
    procedure RefreshRepository;
    procedure NewStatus(const aMsg1, aMsg2: String;const apmsg:Boolean);
    procedure MsgError(const aMsg:String);
    procedure CreateListByRepository;
    procedure EnableAll(const v:Boolean);
  public
    { Public declarations }
  end;

var
  Main: TMain;

implementation

uses
  IniFiles,DelphiGzip,UntFrmDownload;

{$R *.dfm}

procedure TMain.btImportClick(Sender: TObject);
var
  dlg:TOpenDialog;
  sl:TStringList;
  i:Integer;
  d:TDebFile;
begin
  dlg:=TOpenDialog.Create(nil);
  sl:=TStringList.Create;
  try
    if dlg.execute then
      begin
        sl.LoadFromFile(dlg.FileName);
        for i:=0 to sl.count-1 do
          begin
            d:=frep.GetFileByName(sl[i]);
            if assigned(d) then
              begin
                d.InRepository:=True;
              end;
          end;
        // Refresco
        CreateListByRepository;
      end;
  finally
    dlg.Free;
  end;
{
  ms:=TMemoryStream.Create;
  IdHTTP1.Get('http://archive.ubuntu.com/ubuntu/indices/override.breezy-backports.extra.main',ms);
  ms.SaveToFile('c:\test');
}
end;

procedure TMain.NewStatus(const aMsg1:String;const aMsg2:String;const apmsg:Boolean);
begin
  lblstatus1.caption:=aMsg1;
  lblstatus2.caption:=aMsg2;
  if apmsg then
    application.ProcessMessages;
end;

procedure TMain.Crear;
var
  i:TIniFile;
  s:String;
begin
// inicializo
  lblStatus1.caption:='';
  lblStatus2.caption:='';
  fRep:=TRepository.Create;
  Pages.ActivePageIndex:=0;
  chkProxi.Checked:=False;
  edProxiServer.text:='';
  edProxiPort.text:='';
  edProxiUser.text:='';
  edProxiPassword.text:='';
  edRepoDir.text:='';
// Cargo la configuracion
  i:=TIniFile.Create(ExtractFilePath(ParamStr(0))+'config.ini');
  // verifico directorio de repositorios
  edRepoDir.text:=i.ReadString('Cfg','WorkingDir',ExtractFilePath(ParamStr(0))+'repo\');
  s:=Copy(edRepoDir.text,1,length(edRepoDir.text)-1);
  if not DirectoryExists(s) then
    ForceDirectories(s);
    // verifico directorio temporal
  edRepoTmp.text:=i.ReadString('Cfg','WorkingTmp',ExtractFilePath(ParamStr(0))+'tmp\');
  s:=Copy(edRepoDir.text,1,length(edRepoDir.text)-1);
  if not DirectoryExists(s) then
    ForceDirectories(s);
    // configuracion de conexion
  edProxiServer.text:=i.ReadString('Conn','ProxiServer','');
  edProxiPort.text:=i.ReadString('Conn','ProxiPort','');
  edProxiUser.text:=i.ReadString('Conn','ProxiUser','');
  edProxiPassword.text:=i.ReadString('Conn','ProxiPassword','');
  ConnMode.ItemIndex:=i.ReadInteger('Conn','ConnMode',0);
  chkProxi.Checked:=i.ReadBool('Conn','Proxi',False);
  i.Free;
// Cargo el repositorio
  LoadRepository;
end;

procedure TMain.Destruir;
var
  i:TIniFile;
begin
  fRep.Free;
  i:=TIniFile.Create(ExtractFilePath(ParamStr(0))+'config.ini');
  i.WriteString('Cfg','WorkingDir',edRepoDir.text);
  i.WriteString('Cfg','WorkingTmp',edRepoTmp.text);
  i.WriteBool('Conn','Proxi',chkProxi.Checked);
  i.WriteString('Conn','ProxiServer',edProxiServer.text);
  i.WriteString('Conn','ProxiPort',edProxiPort.text);
  i.WriteString('Conn','ProxiUser',edProxiUser.text);
  i.WriteString('Conn','ProxiPassword',edProxiPassword.text);
  i.WriteInteger('Conn','ConnMode',ConnMode.ItemIndex);
  i.UpdateFile;
  i.Free;
end;

procedure TMain.FormCreate(Sender: TObject);
begin
  FileGET:=TIdHTTP.create(nil);
  Crear;
end;

procedure TMain.FormDestroy(Sender: TObject);
begin
  FileGET.Free;
  Destruir;
end;

procedure TMain.btRepoRefreshClick(Sender: TObject);
begin
  LoadRepository;
end;

procedure TMain.LoadRepository;
begin
  if FileExists(edRepoDir.text+'repo.txt') then
    memRepo.Lines.LoadFromFile(edRepoDir.text+'repo.txt');
end;

procedure TMain.btRepoSaveClick(Sender: TObject);
begin
  memRepo.Lines.SaveToFile(edRepoDir.text+'repo.txt');
end;

procedure TMain.btDebRefreshClick(Sender: TObject);
begin
  fRep.Clear;
  RefreshRepository;
  CreateListByRepository;
end;

procedure TMain.AddToRepository(const aUrl:String;const ssl:TStringList;const aUrl2:String);
var
  cc:Integer;
var
  sl:TStringList;
  function GetProp(aName:String):string;
  var
    k:integer;
  begin
    result:='';
    for k:=0 to sl.count-1 do
      begin
        if (Copy(UpperCase(sl[k]),1,length(aname)+2)=UpperCase(aName)+': ') then
          begin
            result:=Copy(sl[k],length(aname)+3,length(sl[k])-length(aname)+3);
          end;
      end;
  end;
  procedure LoadPackage;
  var
    s:String;
    d:TDebFile;
    sfilen,sver,sDepends:String;
  begin
    if (sl.count<=0)or(Copy(UpperCase(sl[0]),1,9)<>'PACKAGE: ') then
      exit;
    s:=GetProp('package');
    inc(cc);
    if cc>10 then
      begin
        NewStatus(aURL,'Actualizando paquete: '+s,true);
        cc:=0;
      end;
    d:=frep.AddFile(s);
    sFilen:=aURL+GetProp('filename');
    sVer:=GetProp('version');
    sDepends:=GetProp('depends');
    if d.UpdateVersion(sVer,sFilen) then
      d.Dependency:=sDepends;
  end;
var
  i,j:Integer;
begin
  cc:=0;
  i:=0;
  sl:=TStringList.Create;
  while i<=ssl.Count-1 do
    begin
      if (Copy(UpperCase(ssl[i]),1,9)='PACKAGE: ') then
        begin
          sl.Clear;
          j:=i;
          while (j<ssl.Count-1)and(Copy(UpperCase(ssl[j+1]),1,9)<>'PACKAGE: ') do
            begin
              sl.Add(ssl[j]);
              inc(j);
            end;
          LoadPackage;
          i:=j;
        end;
      inc(i);
    end;
  sl.Free;
end;

procedure TMain.RefreshRepository;
  function InStr(s1:String;astart,aend:Integer;s2:String):boolean;
  begin
    result:=(UpperCase(Copy(s1,aStart,aEnd))=UpperCase(s2));
  end;
  Function StringField(str:String;aIndex:Integer):String;
  var
    j,k:Integer;
  begin
    str:=Trim(str);
    result:='';
    for j:=0 to aIndex do
      begin
        if j=aIndex then
          begin
            if pos(' ',str)<>0 then
              result:=Copy(str,1,pos(' ',str)-1)
            else
              result:=str;
            exit;
          end
        else
          begin
            k:=pos(' ',str);
            if k=0 then
              exit;
            k:=k+1;
            str:=Copy(str,k,length(str)-k);
          end;
      end;

    if aIndex>0 then
      begin
      end
  end;
var
  i:Integer;
  url,url2,s,p1,p2,p3:String;
{
  ms:TMemoryStream;
}
  e:TGzip;
  sl:TStringList;
begin
  for i:=0 to memRepo.Lines.Count-1 do
    begin
      s:=memRepo.Lines[i];
      //deb http://archive.ubuntu.com/ubuntu edgy main restricted
      if s<>'' then
        begin
          if InStr(s,1,4,'deb ') then
            begin
              try
                p1:=StringField(s,1); // URL
                if p1[Length(p1)]='/' then
                  p1:=copy(p1,1,length(p1)-1);
                p2:=StringField(s,2); // DIST
                p3:=StringField(s,3); // TIPO (main)
                url2:=p1+'/dists/'+p2+'/'+p3+'/binary-'+cbArq.Text+'/';
                url:=url2+'Packages.gz';
                NewStatus('Descargando lista: '+URL,'',true);

                DownLoadFile(url,edRepoTmp.Text+'Packages.gz');

                e:=TGzip.create(nil);
                e.FileSource:=edRepoTmp.Text+'Packages.gz';
                e.FileDestination:=edRepoTmp.Text+'packages';
                e.Gunzip;
                e.Free;
                sl:=TStringList.Create;
                sl.LoadFromFile(edRepoTmp.Text+'packages');
                if sl.text='' then
                  sl.clear;
                sl.SaveToFile(edRepoTmp.Text+'packages');
                AddToRepository(p1+'/',sl,url2);
                sl.Free;
              except
              end;
            end;
        end;
    end;
  NewStatus('Reconstruyendo dependencias','',true);
  frep.BuildDependencies;
  NewStatus('','',true);
end;

procedure TMain.btDownloadClick(Sender: TObject);
var
  lstToInst:TList;
  function AddToDown(const aName:String;const aDeb:TDebFile):Boolean;
  var
    df:TDownloadDeb;
    k:Integer;
  begin
    result:=false;
    for k:=0 to lstToInst.Count-1 do
      begin
        if UpperCase(TDownloadDeb(lstToInst[k]).PackageName)=UpperCase(aName) then
          begin
            result:=True;
            exit;
          end;
      end;
    df:=TDownloadDeb.Create;
    df.PackageName:=aName;
    df.DebFile:=aDeb;
    lstToInst.Add(df);
  end;
  procedure ListDependencies(const aDeb:TDebFile);
  var
    j:Integer;
  begin
    if not AddToDown(aDeb.PackageName,adeb) then
      begin
        for j:=0 to aDeb.DependencyCount-1 do
          begin
            //AddToDown(aDeb.Dependencies[j].PackageName,aDeb.Dependencies[j].Package);
            if Assigned(aDeb.Dependencies[j].Package) then
              ListDependencies(aDeb.Dependencies[j].Package);
          end;
      end;
  end;
var
  i:Integer;
  f:TFrmDownload;
begin
  enableAll(false);
  lstToInst:=nil;
  f:=nil;
  try
    lstToInst:=TList.Create;
    for i:=0 to chklstDEBS.Count-1 do
      begin
        if chklstDEBS.Checked[i] then
          begin
            ListDependencies(TDebfile(chklstDEBS.Items.Objects[i]));
          end;
      end;
    f:=TFrmDownload.Create(nil);
    f.LoadList(lstToInst);
    if f.ShowModal=MrOk then
      begin
        // refresco
        CreateListByRepository;
      end;
    f.Free;
    lstToInst.Free;
  except
    on e:Exception do
      begin
        if assigned(f) then
          f.Free;
        if assigned(lstToInst) then
          lstToInst.Free;
        MsgError(e.message);
      end;
  end;
  enableAll(true);
end;

procedure TMain.btRepoGuardarClick(Sender: TObject);
begin
  EnableAll(false);
  try
    if SaveRepoDlg.execute then
      begin
        fRep.SaveToFile(SaveRepoDlg.FileName);
      end;
  except
    on e:Exception do
      MsgError(e.message);
  end;
  enableAll(true);
end;

procedure TMain.btRepoAbrirClick(Sender: TObject);
begin
  enableAll(false);
  try
    if OpenRepoDlg.execute then
      begin
        fRep.LoadFromFile(OpenRepoDlg.FileName);
        CreateListByRepository;
      end;
  except
    on e:Exception do
      MsgError(e.message);
  end;
  enableAll(true);
end;

procedure TMain.CreateListByRepository;
var
  i:Integer;
  j:Integer;
  s:String;
begin
  chklstDEBS.Clear;
  for i:=0 to fRep.Count-1 do
    begin
      if frep.Files[i].InRepository then
        s:=frep.Files[i].PackageName+' * ('+frep.Files[i].Version+')'
      else
        s:=frep.Files[i].PackageName+' ('+frep.Files[i].Version+')';
      j:=chklstDEBS.Items.AddObject(s,frep.Files[i]);
      chklstDEBS.Checked[j]:=frep.Files[i].InRepository;
    end;
  chklstDEBS.Sorted:=true;
end;

procedure TMain.EnableAll(const v: Boolean);
begin
  btDebRefresh.Enabled:=v;
  btRepoGuardar.Enabled:=v;
  btRepoAbrir.Enabled:=v;
//  btImport.Enabled:=v;
  btDownload.Enabled:=v;
  application.processmessages;
end;

procedure TMain.MsgError(const aMsg: String);
begin
  MessageDlg(aMsg, mtError, [mbOK], 0);
end;

procedure TMain.btUnmmarkClick(Sender: TObject);
var
  i:Integer;
begin
  for i:=0 to chklstDEBS.Count-1 do
    begin
      chklstDEBS.Checked[i]:=False;
    end;
end;

procedure TMain.Button1Click(Sender: TObject);
var
  i:Integer;
begin
  for i:=chklstDEBS.ItemIndex+1 to chklstDEBS.Count-1 do
    begin
      if (pos(upperCase(tbtBuscar.Text),UpperCase(chklstDEBS.Items[i]))>0) then
        begin
          chklstDEBS.ItemIndex:=i;
          exit;
        end;
    end;
  for i:=0 to chklstDEBS.ItemIndex do
    begin
      if (pos(upperCase(tbtBuscar.Text),UpperCase(chklstDEBS.Items[i]))>0) then
        begin
          chklstDEBS.ItemIndex:=i;
          exit;
        end;
    end;
  MsgError('No se ha encontrado');
end;

function TMain.DownLoadFile(const aSource, aDest: String): Boolean;
var
  ms:TMemoryStream;
begin
  if ConnMode.ItemIndex=0 then
    begin
      result:=UrlDownloadToFile(nil,
                PChar(aSource),
                PChar(aDest),
                0, nil)=S_OK;
    end
  else
    begin
      result:=True;
      try
        ms:=TMemoryStream.Create;
        FileGet.get(aSource,ms);
        ms.SaveToFile(adest);
        ms.Free;
      except
        result:=False;
      end;
    end;
end;

procedure TMain.chkProxiClick(Sender: TObject);
begin
  if chkProxi.Checked then
    begin
      FileGet.ProxyParams.ProxyPort:=StrToIntDef(edProxiPort.text,0);
      FileGet.ProxyParams.ProxyServer:=edProxiServer.Text;
      FileGet.ProxyParams.ProxyUsername:=edProxiUser.text;
      FileGet.ProxyParams.ProxyPassword:=edProxiPassword.Text;
    end
  else
    begin
      FileGet.ProxyParams.ProxyPort:=0;
      FileGet.ProxyParams.ProxyServer:='';
      FileGet.ProxyParams.ProxyUsername:='';
      FileGet.ProxyParams.ProxyPassword:='';
    end;
end;

end.


