unit UntFrmDownload;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, CheckLst,urlmon
  ,IdHTTP
  ;

type
  TFrmDownload = class(TForm)
    pnlDownload: TPanel;
    pnlLog: TPanel;
    sp1: TSplitter;
    DownLoadList: TCheckListBox;
    mm: TMemo;
    pnlMenu: TPanel;
    btDownload: TButton;
    procedure FormDestroy(Sender: TObject);
    procedure btDownloadClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
    fDownLoadList:TList;
    fOk:Boolean;
    FileGET:TIdHTTP;
    function DownLoadFile(const aSource,aDest:String):Boolean;
    Function Confirma(const msg:String):Boolean;
  public
    { Public declarations }
    procedure LoadList(const aList:TList);
  end;

var
  FrmDownload: TFrmDownload;

implementation

uses
  UntRepository,MainForm, Math;

{$R *.dfm}

{ TFrmDownload }

procedure TFrmDownload.LoadList(const aList: TList);
var
  i,j:Integer;
  s:String;
  d:TDownloadDeb;
begin
  fDownLoadList:=TList.Create;
  fDownLoadList.Assign(aList);
  DownLoadList.Clear;
  for i:=0 to aList.count-1 do
    begin
      d:=TDownloadDeb(aList[i]);
      if d.PackageName<>'' then
        begin
          s:=d.PackageName+' (';
          if Assigned(d.DebFile) then
            begin
              if not d.DebFile.InRepository then
                s:=s+'Disponible en "'+d.DebFile.Source+'"'
              else
                s:=s+'Ya disponible en el repositorio.';
            end
          else
            s:=s+'No disponible';
          s:=s+')';
          j:=DownLoadList.Items.AddObject(s,d);
          DownLoadList.Checked[j]:=(assigned(d.DebFile))and(not d.DebFile.InRepository);
        end;
    end;
//  DownLoadList.Sorted:=true;
end;

procedure TFrmDownload.FormDestroy(Sender: TObject);
begin
  FileGET.Free;
  // libero
  while fDownLoadList.count>0 do
    begin
      TDownloadDeb(fDownLoadList[0]).Free;
      fDownLoadList.Delete(0);
    end;
  fDownLoadList.Free;
end;

procedure TFrmDownload.btDownloadClick(Sender: TObject);
var
  j:Integer;
  s:String;
  x:Boolean;
  sarc:String;
{
  Ms:TMemoryStream;
}
begin
  x:=False;
  sarc:=Main.cbArq.Text;
  for j:=0 to fDownLoadList.count-1 do
    begin
      if (DownLoadList.Checked[j])and(Assigned(TDownloadDeb(fDownLoadList[j]).DebFile)) then
        begin
          s:=Main.edRepoDir.Text+TDownloadDeb(fDownLoadList[j]).DebFile.PackageName+'_'+TDownloadDeb(fDownLoadList[j]).DebFile.version+'_'+sarc+'.deb';
          If DownLoadFile(
              TDownloadDeb(fDownLoadList[j]).DebFile.Source,
              s) then
            begin
              mm.lines.Add(formatDateTime('dd/mm/yyyy hh:nn:ss',now)+' - Descargando "'+TDownloadDeb(fDownLoadList[j]).DebFile.Source+'"');
              if FileExists(s) then
                begin
                  DownLoadList.Checked[j]:=False;
                  TDownloadDeb(fDownLoadList[j]).DebFile.InRepository:=True;
                  Application.ProcessMessages;
                end
              else
                begin
                  DownLoadList.Checked[j]:=True;
                  TDownloadDeb(fDownLoadList[j]).DebFile.InRepository:=false;
                  x:=True;
                end;
            end
          else
            begin
              mm.lines.Add(formatDateTime('dd/mm/yyyy hh:nn:ss',now)+' - *** No se pudo descargar "'+TDownloadDeb(fDownLoadList[j]).DebFile.Source+'"');
            end;
        end;
    end;
  mm.lines.Add(formatDateTime('dd/mm/yyyy hh:nn:ss',now)+' - Descarga de paquetes terminada.');
  fOk:=True;
end;

function TFrmDownload.DownLoadFile(const aSource, aDest: String): Boolean;
var
  ms:TMemoryStream;
begin
  if Main.ConnMode.ItemIndex=0 then
    begin
      try
        result:=UrlDownloadToFile(nil,
                  PChar(aSource),
                  PChar(aDest),
                  0, nil)=S_OK;
      except
        result:=False;
      end;
    end
  else
    begin
      result:=True;
      try
        ms:=TMemoryStream.Create;
        FileGet.get(aSource,ms);
        ms.SaveToFile(adest);
        ms.Free;
      except
        result:=False;
      end;
    end;
end;

procedure TFrmDownload.FormCreate(Sender: TObject);
begin
  FileGET:=TIdHTTP.create(nil);
  if Main.chkProxi.Checked then
    begin
      FileGet.ProxyParams.ProxyPort:=StrToIntDef(Main.edProxiPort.text,0);
      FileGet.ProxyParams.ProxyServer:=Main.edProxiServer.Text;
      FileGet.ProxyParams.ProxyUsername:=Main.edProxiUser.text;
      FileGet.ProxyParams.ProxyPassword:=Main.edProxiPassword.Text;
    end
  else
    begin
      FileGet.ProxyParams.ProxyPort:=0;
      FileGet.ProxyParams.ProxyServer:='';
      FileGet.ProxyParams.ProxyUsername:='';
      FileGet.ProxyParams.ProxyPassword:='';
    end;
  fOk:=False;
end;

procedure TFrmDownload.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if fOk then
    ModalResult:=MrOk
  else
    ModalResult:=Mrcancel;
end;

function TFrmDownload.Confirma(const msg: String): Boolean;
begin
  result:=(MessageDlg(msg, mtConfirmation, [mbYes, mbNo], 0) = mrYes);
end;

end.
